#{extends 'border.html'/}

<div class="container">
#{form @katalog.PermohonanPembaruanCtr.editSubmitProdukStagingSpec(), method:'POST', class:'form-horizontal save', enctype:'multipart/form-data'}
    <div class="row">
        <div class="col-md-12">
            <!-- Breadcrumb -->
            <ol class="breadcrumb">
                <li><a href="@{PublikCtr.home()}">&{'beranda.label'}</a></li>
                <li><a href="@{katalog.PermohonanPembaruanCtr.index()}">&{'permohonan_pembaruan.label'}</a></li>
                <li class="active">&{'edit.label'} &{'data.label'} &{'spesifikasi.label'} &{'produk.label'}</li>
            </ol>
            <!-- End Breadcrumb -->
        </div>
    </div>

    <!-- Toolbar -->
    <div class="row">
        <div class="col-md-12">
            <div class="toolbar">
                #{backButton action:@katalog.PermohonanPembaruanCtr.index()/}
                #{saveButton/}
            </div>
            #{alert /}
        </div>
    </div>
    <!-- End Toolbar -->

    <div class="row">

        #{alert/}
        <div class="panel panel-default">
            <input type="hidden" required id="kategori_id" name="kategori_id" value="${produk?.produk_kategori_id}">
            <input type="hidden" required id="produk_id" name="produk_id" value="${produk?.id}">
            <input type="hidden" required id="pmb_id" name="pmb_id" value="${pmbstagging?.id}">
            <input type="hidden" class="additional-json" id="infoJson" name="infoJson" value="${attrMapJson != null ? attrMapJson : ""}">
            <div class="panel-body">
                <div id="dynamic-content">

                </div>
            </div>
        </div>
    </div>

#{/form}
</div>

#{set 'moreScripts'}
<script type="text/javascript">
    $(document).ready(function() {

        var classNames = [];

        function generateDynamicForm(value) {
            $.ajax({
                url: "@{katalog.ProdukCtr.getKetagoriAtributByKatId()}",
                type: "post",
                dataType: "json",
                data: {
                    kategori_id: value
                },
                success: function (data) {
                    if(data.length > 0){
                        var values = getAdditionalJson();
                        var content="";
                        $.each(data, function(idx, formAtr){
                            if(formAtr.tipe_input === 'label'){
                                content += "<div class='panel panel-default'>" +
                                        "<div class='panel-heading'><span>"+formAtr.label_atribut+"</span></div>" +
                                        "<div class='panel-body'>";
                                $.each(data, function (index, child) {
                                    if(child.parent_id === formAtr.id){
                                        content += generateDynamicInput(child, getAdditionalDataById(values, formAtr.id));
                                    }
                                });
                                content += "</div></div>";
                            }
                        });
                        $.each(data, function(idx, formAtr){
                            if (formAtr.parent_id == '0' || formAtr.parent_id === '') {
                                content += generateDynamicInput(formAtr, getAdditionalDataById(values, formAtr.id));
                            }
                        });
                        $("#dynamic-content").html(content);
                    }
                }
            });
        }

        function generateDynamicInput(model, value) {
            var attrClass = 'attr-id-' + model.id;
            var required = (model.wajib_diisi == 1) ? ' required' : '';
            if (required) {
                addClassValidation(attrClass);
            }
            var template = '';

            if (model.tipe_input !== 'label') {
                template = "<div class='form-group"+ required +"'>" +
                        "<label class='col-sm-2 control-label'>" + model.label_atribut + "</label>" +
                        "<div class='col-sm-4'>";
                if (model.tipe_input === 'text') {
                    template += "<input type='text' " + required + " " +
                            "data-value='" + model.id + "' " +
                            "class='form-control additional-info' " +
                            "value='" + value + "' " +
                            "name='" + attrClass + "' " +
                            "placeholder='" + model.label_atribut + "'/>";
                } else if (model.tipe_input === 'textarea') {
                    template += "<textarea name='" + attrClass + "' " +
                            "class='form-control additional-info' " +
                            "data-value='" + model.id + "' " + required + ">" + value + "</textarea>"
                }
                template +="</div></div>";
            }
            return template;
        }

        // function regenerateDynamicForm() {
        //     var cat = jQuery(".pilih_kategori").parent().find("select").val();
        //     if (cat !== '' && $("#dynamic-content").children().length === 0) {
        //         generateDynamicForm(cat);
        //     }
        // }

        function getAdditionalJson() {
            var additional = $('.additional-json');
            var json = additional.val();
            var data = {};
            if (json !== '') {
                data = JSON.parse(json);
            }
            return data;
        }

        function getAdditionalDataById(data, key) {
            if (data.hasOwnProperty(key)) {
                return data[key];
            }
            return '';
        }

        function addClassValidation(className) {
            classNames.push(className);
        }

        var value = $("#kategori_id").val();
        generateDynamicForm(value);

        $(document).on('keyup', '.additional-info', function () {
            var view = $(this);
            var value = view.val();
            var id = view.data('value');
            var additional = $('.additional-json');
            var data = getAdditionalJson();
            data[id] = value;
            additional.val(JSON.stringify(data));
        });

    })
</script>
#{/set}